#ifndef _PACKET_H_
#define _PACKET_H_

#include <iostream>
#include <cstring>
#include <cstdio>
#include <errno.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <netinet/in.h>
#include <net/if.h>
#include <linux/if_ether.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>

#ifndef ETH_P_8021X
#define ETH_P_8021X 0x888E
#endif

class packet {
public:
    packet();
    packet(char *ifname);
    ~packet();
    int send(uint8_t *buf, int buf_len);
    int recv(uint8_t *buf, int buf_len);
    uint8_t mac[6];

private:
    int sock;
    sockaddr_ll dev;
    ifreq req;
    int ifindex;
    char ifname[IFNAMSIZ];
    char ifaddr[IFHWADDRLEN];

    int readable_time(int fd, int sec);
};

#endif
